//Conversion de dcimal vers BCD
UCHAR decimal_vers_bcd(UCHAR Valeur)
{
      return (((Valeur/10)<<4)+(Valeur%10));
}


//Conversion de BCD vers dcimal
double bcd_vers_decimal(UCHAR Valeur)
{
      return (((Valeur>>4)*10)+(Valeur%16));
}


// Initialisation de la liaison IC
BOOLEAN InitI2C(IOWKIT_HANDLE IOWarrior)
{
     IOWKIT_SPECIAL_REPORT rapport;
        
    memset(&rapport, 0, 8);
    rapport.ReportID = 0x01;
    rapport.Bytes[0] = 0x01;
    if (IowKitWrite(IOWarrior, 1, (char *) &rapport, 8)  == 8)
       return TRUE;
    else
       return FALSE;
}


// Initialisation de la RTC
void InitRTC(IOWKIT_HANDLE IOWarrior, double *PInput)
{
    IOWKIT_SPECIAL_REPORT rapport;
   
    memset(&rapport, 0, 8);              // Mise  0 de rapport
    rapport.ReportID = 0x02;             //Opration criture
    rapport.Bytes[0] = 0x86;             //Start + 6 bytes
    rapport.Bytes[1] = 0xD0;             //Adresse + ecriture     
    rapport.Bytes[2] = 0x00;             //Adresse du 1er octet de la rtc
    rapport.Bytes[3] = decimal_vers_bcd((UCHAR)PInput[E_sec]);  //seconde
    rapport.Bytes[4] = decimal_vers_bcd((UCHAR)PInput[E_min]);  //minutes
    rapport.Bytes[5] = decimal_vers_bcd((UCHAR)PInput[E_heu]);  //heures
    rapport.Bytes[6] = 0x00;                                    //jour
    IowKitWrite(IOWarrior, 1, (char *) &rapport, 8);            //Ecriture
    IowKitRead(IOWarrior, 1, (char *) &rapport, 8);             //Lecture des erreurs        
    if (rapport.Bytes[0]>0x7F)                                  //Test si erreur
       MessageBox(NULL,TEXT("Erreur de transmission"),TEXT("InitialisationRTC"), MB_OK);
    memset(&rapport, 0, 8);                        // Mise  0 de rapport
    rapport.ReportID = 0x02;                       //Opration criture
    rapport.Bytes[0] = 0x43;                       //3 bytes + stop 
    rapport.Bytes[1] = decimal_vers_bcd((UCHAR)PInput[E_dat]);  //date
    rapport.Bytes[2] = decimal_vers_bcd((UCHAR)PInput[E_moi]);  //mois
    rapport.Bytes[3] = decimal_vers_bcd((UCHAR)(PInput[E_ann]-2000));  //anne
    IowKitWrite(IOWarrior, 1, (char *) &rapport, 8);                   //Ecriture
    IowKitRead(IOWarrior, 1, (char *) &rapport, 8);                    //Lecture des erreurs
    if (rapport.Bytes[0]>0x7F)                                         //Test si erreur
       MessageBox(NULL,TEXT("Erreur de transmission"),TEXT("InitialisationRTC"), MB_OK);
}

// Lecture de l'heure de la RTC
IOWKIT_SPECIAL_REPORT Lecture_heureRTC(IOWKIT_HANDLE IOWarrior)
{
     IOWKIT_SPECIAL_REPORT rapport;
        
     //initialisation du pointeur
                                                      // Mise  0 de rapport
                                                      //Fonction criture
                                                      //Start + stop + 2 bytes
                                                      //Adresse + ecriture
                                                      //Adresse du 1er octet de la rtc
                                                      //Ecriture des donnes
                                                      //Lecture des erreurs
                                                      //Test si erreur

       
     //demande de lecture des 3 octets
                                                      // Mise  0 de rapport
                                                      //Opration lecture
                                                      //nombre d'octets  lire
                                                      //Adresse + lecture
                                                      //Ecriture des donnes
                                                      //Lecture des erreurs et donnes
                                                     

     return rapport;                                  //Retourner les donnes lues
}


// Lecture de la date de la RTC
IOWKIT_SPECIAL_REPORT Lecture_dateRTC(IOWKIT_HANDLE IOWarrior)
{
    IOWKIT_SPECIAL_REPORT rapport;
       
    
    //initialisation du pointeur
                                                    // Mise  0 de rapport
                                                    //Fonction ecriture
                                                    //Start + stop + 2 bytes
                                                    //Adresse + ecriture
                                                    //Adresse du 1er octet de la date de la rtc
                                                    //Ecriture des donnes
                                                    //Lecture des erreurs
                                                    //Test si erreur
    
    
    //demande de lecture des 4 octets
                                                    // Mise  0 de rapport
                                                    //Fonction lecture
                                                    //nombre d'octets  lire
                                                    //Adresse + lecture
                                                    //Ecriture des commandes
                                                    //Lecture des erreurs et donnes
                                                    

                                                    //Retourner les donnes lues
}
