//Conversion de dcimal vers BCD
UCHAR decimal_vers_bcd(UCHAR Valeur)
{
      return (((Valeur/10)<<4)+(Valeur%10));
}


//Conversion de BCD vers dcimal
double bcd_vers_decimal(UCHAR Valeur)
{
      return (((Valeur>>4)*10)+(Valeur%16));
}

// Initialisation de la liaison IC
BOOLEAN InitI2C(IOWKIT_HANDLE IOWarrior, ULONG Pid)
{
     IOWKIT_SPECIAL_REPORT report;
        
     switch (Pid)
     {
            case IOWKIT_PID_IOW24 :
                 memset(&report, 0, IOWKIT_SPECIAL_REPORT_SIZE);
                 report.ReportID = 0x01;
                 report.Bytes[0] = 0x01;
                 IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 return TRUE;
            default :
                 return FALSE;
     }
}
      
            
// Fermeture de la  de la liaison IC
BOOLEAN CloseI2C(IOWKIT_HANDLE IOWarrior, ULONG Pid)
{
     IOWKIT_SPECIAL_REPORT report;
     
     switch (Pid)
     {
            case IOWKIT_PID_IOW24 :
                 memset(&report, 0, IOWKIT_SPECIAL_REPORT_SIZE);
                 report.ReportID = 0x01;
                 report.Bytes[0] = 0x00;
                 IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 return TRUE;
            default :
                 return FALSE;
     }
}

// Initialisation de la RTC
BOOLEAN InitRTC(IOWKIT_HANDLE IOWarrior, ULONG Pid, double *PInput)
{
     IOWKIT_SPECIAL_REPORT report;
   
    
     switch (Pid)
     {
            case IOWKIT_PID_IOW24 :
                 memset(&report, 0, IOWKIT_SPECIAL_REPORT_SIZE); // Mise  0 de report
                 report.ReportID = 0x02;
                 report.Bytes[0] = 0x86;  //Start + 6 bytes
                 report.Bytes[1] = 0xD0; //UCHAR) PInput[ADR]; //addr; //0xD0;  //Adresse + ecriture
                 report.Bytes[2] = 0x00;  //Adresse du 1er octet de la rtc
                 report.Bytes[3] = decimal_vers_bcd((UCHAR)PInput[E_sec]);  //seconde
                 report.Bytes[4] = decimal_vers_bcd((UCHAR)PInput[E_min]);  //minutes
                 report.Bytes[5] = decimal_vers_bcd((UCHAR)PInput[E_heu]);  //heures
                 report.Bytes[6] = decimal_vers_bcd((UCHAR)PInput[E_jou]);  //jour
                 IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 IowKitRead(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 if (report.Bytes[0]>0x7F) 
                      MessageBox(NULL,TEXT("Erreur de transmission"),TEXT("Ecriture"), MB_OK);
                 memset(&report, 0, IOWKIT_SPECIAL_REPORT_SIZE); // Mise  0 de report
                 report.ReportID = 0x02;
                 report.Bytes[0] = 0x43;  //3 bytes + stop 
                 report.Bytes[1] = decimal_vers_bcd((UCHAR)PInput[E_dat]);  //date
                 report.Bytes[2] = decimal_vers_bcd((UCHAR)PInput[E_moi]);  //mois
                 report.Bytes[3] = decimal_vers_bcd((UCHAR)(PInput[E_ann]-2000));  //anne
                 IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 IowKitRead(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 if (report.Bytes[0]>0x7F) 
                      MessageBox(NULL,TEXT("Erreur de transmission"),TEXT("Ecriture"), MB_OK);
                 return TRUE;
            default :
                 return FALSE;
     }
}

// Lecture de l'heure de la RTC
IOWKIT_SPECIAL_REPORT Lecture_heureRTC(IOWKIT_HANDLE IOWarrior, ULONG Pid)
{
     IOWKIT_SPECIAL_REPORT report;
        
     switch (Pid)
     {
            case IOWKIT_PID_IOW24 :
                 //initialisation du pointeur
                 memset(&report, 0, IOWKIT_SPECIAL_REPORT_SIZE); // Mise  0 de report
                 report.ReportID = 0x02;
                 report.Bytes[0] = 0xc2;  //Start + stop + 2 bytes
                 report.Bytes[1] = 0xD0;  //Adresse + ecriture
                 report.Bytes[2] = 0x00;  //Adresse du 1er octet de la rtc
                 IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 IowKitRead(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 //demande de lecture des 3 octets
                 memset(&report, 0, IOWKIT_SPECIAL_REPORT_SIZE); // Mise  0 de report
                 report.ReportID = 0x03;  //Lecture
                 report.Bytes[0] = 0x03;  //nombre d'octets  lire
                 report.Bytes[1] = 0xD1;  //Adresse + lecture
                 IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 IowKitRead(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 return report;
            //default :
              //   return FALSE;
     }
}


// Lecture de la date de la RTC
IOWKIT_SPECIAL_REPORT Lecture_dateRTC(IOWKIT_HANDLE IOWarrior, ULONG Pid)
{
     IOWKIT_SPECIAL_REPORT report;
        
     switch (Pid)
     {
            case IOWKIT_PID_IOW24 :
                 //initialisation du pointeur
                 memset(&report, 0, IOWKIT_SPECIAL_REPORT_SIZE); // Mise  0 de report
                 report.ReportID = 0x02;
                 report.Bytes[0] = 0xc2;  //Start + stop + 2 bytes
                 report.Bytes[1] = 0xD0;  //Adresse + ecriture
                 report.Bytes[2] = 0x03;  //Adresse du 1er octet de la date de la rtc
                 IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 IowKitRead(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 //demande de lecture des 4 octets
                 memset(&report, 0, IOWKIT_SPECIAL_REPORT_SIZE); // Mise  0 de report
                 report.ReportID = 0x03;  //Lecture
                 report.Bytes[0] = 0x04;  //nombre d'octets  lire
                 report.Bytes[1] = 0xD1;  //Adresse + lecture
                 IowKitWrite(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 IowKitRead(IOWarrior, IOW_PIPE_SPECIAL_MODE, (char *) &report, IOWKIT_SPECIAL_REPORT_SIZE);
                 return report;
            //default :
              //   return FALSE;
     }
}







/*
BOOLEAN WriteSimple(IOWKIT_HANDLE devHandle, DWORD value)
{
	IOWKIT56_IO_REPORT rep;

	// Init report
	memset(&rep, 0xff, IOWKIT56_IO_REPORT_SIZE);
	rep.ReportID = 0;
	switch (IowKitGetProductId(devHandle))
	{
	// Write simple value to IOW40
	case IOWKIT_PRODUCT_ID_IOW40:
		rep.Bytes[3] = (BYTE) value;
		return IowKitWrite(devHandle, IOW_PIPE_IO_PINS,
			(PCHAR) &rep, IOWKIT40_IO_REPORT_SIZE) == IOWKIT40_IO_REPORT_SIZE;
	// Write simple value to IOW24
	case IOWKIT_PRODUCT_ID_IOW24:
		rep.Bytes[0] = (BYTE) value;
		return IowKitWrite(devHandle, IOW_PIPE_IO_PINS,
			(PCHAR) &rep, IOWKIT24_IO_REPORT_SIZE) == IOWKIT24_IO_REPORT_SIZE;
	case IOWKIT_PRODUCT_ID_IOW56:
	// Write simple value to IOW56
		rep.Bytes[6] = (BYTE) value;
		return IowKitWrite(devHandle, IOW_PIPE_IO_PINS,
			(PCHAR) &rep, IOWKIT56_IO_REPORT_SIZE) == IOWKIT56_IO_REPORT_SIZE;
	default:
		return FALSE;
	}
}
*/
